#  Copyright 2022 Amazon.com, Inc. or its affiliates. All Rights Reserved.
#  SPDX-License-Identifier: Apache-2.0
from dataclasses import dataclass


@dataclass
class Limits:
    """1/number should be rational"""

    CODEBUILD_CONCURRENT_PROJECTS = ("CODEBUILD_CONCURRENT_PROJECTS", 5)
    SSM_GET_PARAMETER_BY_PATH_PER_REGION_OF_ACCOUNT = (
        "SSM_GET_PARAMETER_BY_PATH_PER_REGION_OF_ACCOUNT",
        5,
    )
    SSM_GET_PARAMETER_PER_REGION_OF_ACCOUNT = (
        "SSM_GET_PARAMETER_PER_REGION_OF_ACCOUNT",
        5,
    )
    SSM_PUT_PARAMETER_PER_REGION_OF_ACCOUNT = (
        "SSM_PUT_PARAMETER_PER_REGION_OF_ACCOUNT",
        5,
    )
    SSM_DELETE_PARAMETER_PER_REGION_OF_ACCOUNT = (
        "SSM_DELETE_PARAMETER_PER_REGION_OF_ACCOUNT",
        5,
    )
    SERVICE_CATALOG_SCAN_PROVISIONED_PRODUCTS_PER_REGION_OF_ACCOUNT = (
        "SERVICE_CATALOG_SCAN_PROVISIONED_PRODUCTS_PER_REGION_OF_ACCOUNT",
        5,
    )
    SERVICE_CATALOG_DESCRIBE_PROVISIONED_PRODUCT_PER_REGION_OF_ACCOUNT = (
        "SERVICE_CATALOG_DESCRIBE_PROVISIONED_PRODUCT_PER_REGION_OF_ACCOUNT",
        5,
    )
    CLOUDFORMATION_LIST_STACKS_PER_REGION_OF_ACCOUNT = (
        "CLOUDFORMATION_LIST_STACKS_PER_REGION_OF_ACCOUNT",
        5,
    )
    CLOUDFORMATION_ENSURE_DELETED_PER_REGION_OF_ACCOUNT = (
        "CLOUDFORMATION_ENSURE_DELETED_PER_REGION_OF_ACCOUNT",
        4,
    )
    CLOUDFORMATION_GET_TEMPLATE_SUMMARY_PER_REGION_OF_ACCOUNT = (
        "CLOUDFORMATION_GET_TEMPLATE_SUMMARY_PER_REGION_OF_ACCOUNT",
        5,
    )
    CLOUDFORMATION_GET_TEMPLATE_PER_REGION_OF_ACCOUNT = (
        "CLOUDFORMATION_GET_TEMPLATE_PER_REGION_OF_ACCOUNT",
        5,
    )
    CLOUDFORMATION_CREATE_OR_UPDATE_PER_REGION_OF_ACCOUNT = (
        "CLOUDFORMATION_CREATE_OR_UPDATE_PER_REGION_OF_ACCOUNT",
        4,
    )
